﻿using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Verse;

namespace AdvancedDoorsSOS
{
	public class Building_AdvancedDoorAirlock : Building_ShipAirlock
	{
		private Graphic graphicIntRight;
		public Graphic DefaultGraphicRight
		{
			get
			{
				if (graphicIntRight == null)
				{
					var newTexPath = def.graphicData.texPath;
					newTexPath = newTexPath.Remove(newTexPath.Length - 1, 1) + "R";
					var otherGraphicData = new GraphicData
					{
						texPath = newTexPath,
						graphicClass = def.graphicData.graphicClass,
						shadowData = def.graphicData.shadowData,
						shaderType = def.graphicData.shaderType,
						shaderParameters = def.graphicData.shaderParameters,
						onGroundRandomRotateAngle = def.graphicData.onGroundRandomRotateAngle,
						linkType = def.graphicData.linkType,
						linkFlags = def.graphicData.linkFlags,
						flipExtraRotation = def.graphicData.flipExtraRotation,
						drawSize = def.graphicData.drawSize,
						drawRotated = !def.graphicData.drawRotated,
						drawOffsetWest = def.graphicData.drawOffsetWest,
						drawOffsetSouth = def.graphicData.drawOffsetSouth,
						drawOffsetNorth = def.graphicData.drawOffsetNorth,
						drawOffsetEast = def.graphicData.drawOffsetEast,
						drawOffset = def.graphicData.drawOffset,
						damageData = def.graphicData.damageData,
						colorTwo = def.graphicData.colorTwo,
						color = def.graphicData.color,
						allowFlip = def.graphicData.allowFlip
					};
					graphicIntRight = otherGraphicData.GraphicColoredFor(this);
				}
				return graphicIntRight;
			}
		}
		public Graphic GraphicRight => DefaultGraphicRight;

		public override void Draw()
		{
			base.Rotation = DoorRotationAt(base.Position, base.Map);
			float num = Mathf.Clamp01((float)ticksSinceOpen / (float)TicksToOpenNow);
			float d = 0f + 0.45f * num;
			for (int i = 0; i < 2; i++)
			{
				Vector3 vector = default(Vector3);
				Mesh mesh = MeshPool.plane10; ;
				Material mat = null;
				if (i == 0)
				{
					vector = new Vector3(0f, 0f, -1f);
					mat = Graphic.MatAt(base.Rotation);
				}
				else
				{
					vector = new Vector3(0f, 0f, 1f);
					mat = GraphicRight.MatAt(base.Rotation);
				}
				Rot4 rotation = base.Rotation;
				rotation.Rotate(RotationDirection.Clockwise);
				vector = rotation.AsQuat * vector;
				Vector3 drawPos = DrawPos;
				drawPos.y = AltitudeLayer.DoorMoveable.AltitudeFor();
				drawPos += vector * d;
				if (mat != null)
				{
					Graphics.DrawMesh(mesh, drawPos, base.Rotation.AsQuat, mat, 0);
				}
			}
			Comps_PostDraw();
		}
	}
}
